var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useCallback, useEffect, useState } from 'react';
import useServiceWorker from '../hooks/use-service-worker';
import PushSubscriptionDialog from './PushSubscriptionDialog';
var urlB64ToUint8Array = function (base64String) {
    var padding = '='.repeat((4 - base64String.length % 4) % 4);
    var base64 = (base64String + padding)
        .replace(/-/g, '+')
        .replace(/_/g, '/');
    var rawData = window.atob(base64);
    var outputArray = new Uint8Array(rawData.length);
    for (var i = 0; i < rawData.length; ++i) {
        outputArray[i] = rawData.charCodeAt(i);
    }
    return outputArray;
};
// ako ništa, za 24 sata
// ako ne, hvala za 45 dana
var PushSubscription = function (_a) {
    var debug = _a.debug, DialogProps = _a.DialogProps, publicKey = _a.publicKey, saveUrl = _a.saveUrl;
    var registration = useServiceWorker();
    var _b = useState(), subscription = _b[0], setSubscription = _b[1];
    var _c = useState(false), showDialog = _c[0], setShowDialog = _c[1];
    if (!('PushManager' in window)) {
        console.warn('No push support.');
        return null;
    }
    var subscribeUser = useCallback(function (registration) {
        if (registration) {
            registration.pushManager.subscribe({
                userVisibleOnly: true,
                applicationServerKey: urlB64ToUint8Array(publicKey)
            })
                .then(function (subscription) {
                setSubscription(subscription);
            })
                .catch(function (err) {
                console.error('Error while subscribing to push.', err);
            });
        }
    }, [publicKey, registration]);
    var onDialogAcceptHandler = useCallback(function () {
        setShowDialog(false);
        subscribeUser(registration);
    }, [registration]);
    var onDialogDeclineHandler = useCallback(function () {
        localStorage.setItem('tiara_push_declined', '1');
        setShowDialog(false);
    }, []);
    useEffect(function () {
        if (registration) {
            {
                debug && console.log('@tiara/push: Getting the subscription...');
            }
            registration.pushManager.getSubscription()
                .then(function (subscription) {
                if (subscription) {
                    var dec = new TextDecoder('utf-8');
                    if (dec.decode(urlB64ToUint8Array(publicKey)) !== dec.decode(subscription.options.applicationServerKey)) {
                        subscription.unsubscribe().then(function () {
                            subscribeUser();
                        });
                    }
                    else {
                        setSubscription(subscription);
                    }
                }
                else if (debug) {
                    console.log('@tiara/push: No subscription found.');
                }
            })
                .catch(function (err) {
                console.error('@tiara/push: Error while getting push subscription.', err);
            });
        }
    }, [registration]);
    useEffect(function () {
        if (subscription) {
            fetch(saveUrl, {
                method: 'POST',
                headers: { 'Content-Type': 'application/json' },
                body: JSON.stringify(subscription.toJSON()),
            }).then();
        }
    }, [saveUrl, subscription]);
    if (Notification.permission === 'denied' || subscription) {
        return null;
    }
    var lastAsk = parseInt(localStorage.getItem('tiara_push_lastAsk') || '');
    var shouldAsk = !lastAsk ||
        (localStorage.getItem('tiara_push_declined') && (new Date()).getTime() - lastAsk > (86400000 * 45)) ||
        (!localStorage.getItem('tiara_push_declined') && (new Date()).getTime() - lastAsk > 86400000);
    if (shouldAsk) {
        setTimeout(function () {
            localStorage.setItem('tiara_push_lastAsk', (new Date()).getTime().toString());
            setShowDialog(true);
        }, 3000);
    }
    return (_jsx(PushSubscriptionDialog, __assign({}, (DialogProps || {}), { open: showDialog, onAccept: onDialogAcceptHandler, onDecline: onDialogDeclineHandler }), void 0));
};
export default PushSubscription;
