import { useEffect, useState } from 'react';
var useServiceWorker = function () {
    if (!('serviceWorker' in navigator)) {
        console.warn('No service worker support.');
        return null;
    }
    var _a = useState(null), registration = _a[0], setRegistration = _a[1];
    useEffect(function () {
        navigator.serviceWorker.register('/sw.js')
            .then(function (reg) {
            setRegistration(reg);
            return reg;
        })
            .catch(function (err) {
            console.error('Error while registering the service worker.', err);
        });
    }, []);
    return registration;
};
export default useServiceWorker;
