<?php
declare(strict_types=1);

namespace Tiara\Push;

/**
 * Class ConfigProvider
 *
 * @package Tiara\Push
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/tiara-push
 */
final class ConfigProvider
{
    public function __invoke(): array
    {
        return [
            'dependencies' => $this->getDependencies(),
            'push' => $this->getPushConfig(),
        ];
    }

    public function getPushConfig(): array
    {
        return [
            'connection' => 'default',
        ];
    }

    public function getDependencies(): array
    {
        return [
            'factories' => [
                Handler\Subscription\Save::class => Handler\Subscription\SaveFactory::class,
                Middleware\PushMiddleware::class => Middleware\PushMiddlewareFactory::class,
                Service\SubscriptionManagerInterface::class => Service\SubscriptionManagerFactory::class,
            ],
        ];
    }
}