<?php
declare(strict_types=1);

namespace Tiara\Push\Handler\Subscription;

use Psr\Container\ContainerInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Tiara\Push\Service\SubscriptionManagerInterface;

/**
 * Class SaveFactory
 *
 * @package Tiara\Push\Handler\Subscription
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/tiara-push
 */
final class SaveFactory
{
    /**
     * @param ContainerInterface $container
     * @return RequestHandlerInterface
     */
    public function __invoke(ContainerInterface $container): RequestHandlerInterface
    {
        return new Save(
            $container->get(SubscriptionManagerInterface::class)
        );
    }
}